VERSION 5.00
Object = "{FE0065C0-1B7B-11CF-9D53-00AA003C9CB6}#1.1#0"; "COMCT232.OCX"
Begin VB.Form dlgEditRegValue 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Dialog Caption"
   ClientHeight    =   1695
   ClientLeft      =   6105
   ClientTop       =   5115
   ClientWidth     =   3390
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   1695
   ScaleWidth      =   3390
   ShowInTaskbar   =   0   'False
   Begin ComCtl2.UpDown updHex 
      Height          =   375
      Left            =   1080
      TabIndex        =   7
      Top             =   225
      Width           =   240
      _ExtentX        =   423
      _ExtentY        =   661
      _Version        =   327681
      OrigLeft        =   1200
      OrigTop         =   240
      OrigRight       =   1440
      OrigBottom      =   615
      Enabled         =   -1  'True
   End
   Begin ComCtl2.UpDown updBin 
      Height          =   375
      Left            =   2895
      TabIndex        =   6
      Top             =   240
      Width           =   240
      _ExtentX        =   423
      _ExtentY        =   661
      _Version        =   327681
      Enabled         =   -1  'True
   End
   Begin VB.TextBox txtRegBin 
      Height          =   375
      Left            =   2085
      MaxLength       =   8
      TabIndex        =   3
      Text            =   "00000000"
      Top             =   240
      Width           =   855
   End
   Begin VB.TextBox txtRegHex 
      Height          =   375
      Left            =   720
      MaxLength       =   2
      TabIndex        =   2
      Text            =   "00"
      Top             =   225
      Width           =   390
   End
   Begin VB.CommandButton CancelButton 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   1800
      TabIndex        =   1
      Top             =   975
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   330
      TabIndex        =   0
      Top             =   975
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Binary :"
      Height          =   255
      Left            =   1530
      TabIndex        =   5
      Top             =   255
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Hex :"
      Height          =   255
      Left            =   270
      TabIndex        =   4
      Top             =   255
      Width           =   495
   End
End
Attribute VB_Name = "dlgEditRegValue"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim UserValue As Integer
Dim BinTxtFocus As Boolean
Dim HexTxtFocus As Boolean

Private Sub Form_Activate()
    dlgEditRegValue.Caption = RegisterCaption
    txtRegHex.Text = AddZero(Registers(CurrentRegNum))
    txtRegBin.Text = Display8Bit(Registers(CurrentRegNum))
    
    OKButton.Default = True
    UserValue = Registers(CurrentRegNum)
End Sub

Private Sub Form_Deactivate()
    Call dlgEditRegValue.Hide
End Sub

Private Sub OKButton_Click()
    Call WriteRegister(CurrentRegNum, AddZero(UserValue))
    Call UpdateRegistersAllForms
    Call dlgEditRegValue.Hide
End Sub


Private Sub CancelButton_Click()
    Call dlgEditRegValue.Hide
End Sub

Private Sub txtRegBin_KeyPress(KeyAscii As Integer)
    Dim Char As String
    Char = UCase(Chr(KeyAscii))
                ' ignore the keystroke if it's
                ' a letter but not "1" or "0"
    If KeyAscii >= 32 And Char <> "0" And Char <> "1" Then
        Beep
        KeyAscii = 0
    End If
End Sub

Private Sub txtRegBin_Change()
    If BinTxtFocus = False Then
                    ' return if the event was caused by
                    ' a change in another text box
        Exit Sub
    End If
    If Len(txtRegBin.Text) > 8 Then
        Beep
        txtRegBin.Text = Left(txtRegBin.Text, 8)
    End If
    UserValue = BinStr2Val(txtRegBin.Text)
    txtRegHex.Text = Format(Hex(UserValue), "00")
End Sub

Private Sub txtRegBin_GotFocus()
    BinTxtFocus = True
End Sub

Private Sub txtRegBin_LostFocus()
    BinTxtFocus = False
End Sub

Private Sub txtRegHex_KeyPress(KeyAscii As Integer)
    Dim Char As String
    Char = UCase(Chr(KeyAscii))
                ' ignore the keystroke if it's
                ' a letter but not a hex digit
    If (Char >= "0" And Char <= "9") Or (Char >= "A" And Char <= "F") Then
        KeyAscii = Asc(Char)
    Else
        If KeyAscii >= 32 Then
            Beep
            KeyAscii = 0
        End If
    End If
End Sub

Private Sub txtRegHex_Change()
    If HexTxtFocus = False Then
                    ' return if the event was caused by
                    ' a change in another text box
        Exit Sub
    End If
    If Len(txtRegHex.Text) > 2 Then
        Beep
        txtRegHex.Text = Left(txtRegHex.Text, 2)
    End If
    UserValue = Val("&H" & txtRegHex.Text)
    txtRegBin.Text = Display8Bit(UserValue)
End Sub

Private Sub txtRegHex_GotFocus()
    HexTxtFocus = True
End Sub

Private Sub txtRegHex_LostFocus()
    HexTxtFocus = False
End Sub

Private Sub updHex_UpClick()
    If UserValue < 255 Then
        UserValue = UserValue + 1
    Else
        Beep
    End If
    txtRegHex.Text = Hex(UserValue)
    txtRegBin.Text = Display8Bit(CInt(UserValue))

End Sub
Private Sub updHex_DownClick()
    If UserValue > 0 Then
        UserValue = UserValue - 1
    Else
        Beep
    End If
    txtRegHex.Text = Hex(UserValue)
    txtRegBin.Text = Display8Bit(CInt(UserValue))
End Sub
Private Sub updBin_UpClick()
    If UserValue < 255 Then
        UserValue = UserValue + 1
    Else
        Beep
    End If
    txtRegHex.Text = Hex(UserValue)
    txtRegBin.Text = Display8Bit(CInt(UserValue))

End Sub
Private Sub updBin_DownClick()
    If UserValue > 0 Then
        UserValue = UserValue - 1
    Else
        Beep
    End If
    txtRegHex.Text = Hex(UserValue)
    txtRegBin.Text = Display8Bit(CInt(UserValue))
End Sub
