VERSION 5.00
Begin VB.Form frmCalOver_Under_Scale 
   Caption         =   "Cal Over / Under Scale"
   ClientHeight    =   6855
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4695
   LinkTopic       =   "Form1"
   ScaleHeight     =   6855
   ScaleWidth      =   4695
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Caption         =   "Compute Adjusted Limits"
      Height          =   2775
      Left            =   240
      TabIndex        =   6
      Top             =   3840
      Width           =   3855
      Begin VB.CommandButton Command6 
         Caption         =   "Write EEPROM"
         Height          =   375
         Left            =   360
         TabIndex        =   15
         Top             =   2280
         Width           =   3255
      End
      Begin VB.CommandButton Command5 
         Caption         =   "Write XTR"
         Height          =   375
         Left            =   360
         TabIndex        =   14
         Top             =   1800
         Width           =   3255
      End
      Begin VB.TextBox txtMeasOverScale 
         Height          =   285
         Left            =   2520
         TabIndex        =   11
         Top             =   360
         Width           =   1095
      End
      Begin VB.TextBox txtMeasUnderScale 
         Height          =   285
         Left            =   2520
         TabIndex        =   10
         Top             =   840
         Width           =   1095
      End
      Begin VB.CommandButton Command2 
         Caption         =   "Compute Adjusted Limit"
         Height          =   375
         Left            =   360
         TabIndex        =   7
         Top             =   1320
         Width           =   3255
      End
      Begin VB.Label Label4 
         Caption         =   "Measured Over Scale Limit"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   360
         Width           =   1935
      End
      Begin VB.Label Label3 
         Caption         =   "Measured Under Scale Limit"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   840
         Width           =   2175
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Initial Settings"
      Height          =   3495
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   3855
      Begin VB.ComboBox Combo1 
         Height          =   315
         Left            =   1320
         Style           =   2  'Dropdown List
         TabIndex        =   16
         Top             =   480
         Width           =   1455
      End
      Begin VB.CommandButton Command4 
         Caption         =   "Write EEPROM"
         Height          =   375
         Left            =   480
         TabIndex        =   13
         Top             =   2880
         Width           =   2895
      End
      Begin VB.CommandButton Command3 
         Caption         =   "Write XTR"
         Height          =   375
         Left            =   480
         TabIndex        =   12
         Top             =   2400
         Width           =   2895
      End
      Begin VB.TextBox txtTargetUnderscaleLimit 
         Height          =   285
         Left            =   2280
         TabIndex        =   3
         Top             =   1560
         Width           =   1095
      End
      Begin VB.TextBox txtTargetOverscaleLimit 
         Height          =   285
         Left            =   2280
         TabIndex        =   2
         Top             =   1050
         Width           =   1095
      End
      Begin VB.CommandButton Command1 
         Caption         =   "Compute Over / Under Limit"
         Height          =   375
         Left            =   480
         TabIndex        =   1
         Top             =   1920
         Width           =   2895
      End
      Begin VB.Label Label38 
         Caption         =   "Mode"
         Height          =   255
         Left            =   600
         TabIndex        =   17
         Top             =   480
         Width           =   735
      End
      Begin VB.Label Label2 
         Caption         =   "Target Under Scale Limit"
         Height          =   255
         Left            =   360
         TabIndex        =   5
         Top             =   1560
         Width           =   1815
      End
      Begin VB.Label Label1 
         Caption         =   "Target Over Scale Limit"
         Height          =   255
         Left            =   360
         TabIndex        =   4
         Top             =   1080
         Width           =   1935
      End
   End
End
Attribute VB_Name = "frmCalOver_Under_Scale"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Text2_Change()

End Sub

Private Sub Command1_Click()
If Combo1 = "Current" Then
    If (Val(txtTargetOverscaleLimit) > 28.5) Then
        MsgBox "The maximum overscale limit target is 28.0mA"
        txtTargetOverscaleLimit = ""
        Exit Sub
    End If
    If (Val(txtTargetOverscaleLimit) < 20.5) Then
        MsgBox "The minimum overscale limit target is 28.0mA"
        txtTargetOverscaleLimit = ""
        Exit Sub
    End If
    If (Val(txtTargetUnderscaleLimit) > 3.8) Then
        MsgBox "The maximum underscale limit target is 3.8mA"
        txtTargetUnderscaleLimit = ""
        Exit Sub
    End If
    If (Val(txtTargetUnderscaleLimit) < 2.4) Then
        MsgBox "The minimum overscale limit target is 2.4mA"
        txtTargetUnderscaleLimit = ""
        Exit Sub
    End If
Else
    If (Val(txtTargetOverscaleLimit) > 3.5 + 0.06) Then
        MsgBox "The maximum overscale limit target is 3.5V"
        txtTargetOverscaleLimit = ""
        Exit Sub
    End If
    If (Val(txtTargetOverscaleLimit) < 2.5625 - 0.06) Then
        MsgBox "The minimum overscale limit target is 2.5625V"
        txtTargetOverscaleLimit = ""
        Exit Sub
    End If
    If (Val(txtTargetUnderscaleLimit) > 0.475 + 0.06) Then
        MsgBox "The maximum underscale limit target is 0.475V"
        txtTargetUnderscaleLimit = ""
        Exit Sub
    End If
    If (Val(txtTargetUnderscaleLimit) < 0.3 - 0.06) Then
        MsgBox "The minimum overscale limit target is 0.3V"
        txtTargetUnderscaleLimit = ""
        Exit Sub
    End If
End If
min_OVER_error = 1000000#
min_UNDER_error = 1000000#

For jj = 0 To 15
    If Combo1 = "Current" Then
        Error_over = Abs(OverLimit_I_val(jj) - Val(txtTargetOverscaleLimit))
    Else
        Error_over = Abs(OverLimit_V_val(jj) - Val(txtTargetOverscaleLimit))
    End If
    If Error_over < min_OVER_error Then
        OVER_INDEX = jj
        min_OVER_error = Error_over
    End If
Next jj
For jj = 0 To 7
    If Combo1 = "Current" Then
        Error_under = Abs(UnderLimit_I_val(jj) - Val(txtTargetUnderscaleLimit))
    Else
        Error_under = Abs(UnderLimit_V_val(jj) - Val(txtTargetUnderscaleLimit))
    End If
    If Error_under < min_UNDER_error Then
        UNDER_INDEX = jj
        min_UNDER_error = Error_under
    End If
Next jj
       'IVal = Val(edBitVal(8)) + Val(edBitVal(9)) * 2 + Val(edBitVal(10)) * 4

        'IVal = Val(edBitVal(4)) + Val(edBitVal(5)) * 2 + Val(edBitVal(6)) * 4 + Val(edBitVal(7)) * 8

'MsgBox "V=" + Str(OverLimit_I_val(OVER_INDEX)) + vbCrLf + "c=" + Str(UnderLimit_I_val(UNDER_INDEX))
  frmRegDetail.edBitVal(4) = (OVER_INDEX And &H1)
  frmRegDetail.edBitVal(5) = (OVER_INDEX And &H2) / 2
  frmRegDetail.edBitVal(6) = (OVER_INDEX And &H4) / 4
  frmRegDetail.edBitVal(7) = (OVER_INDEX And &H8) / 8
  
  frmRegDetail.edBitVal(8) = (UNDER_INDEX And &H1)
  frmRegDetail.edBitVal(9) = (UNDER_INDEX And &H2) / 2
  frmRegDetail.edBitVal(10) = (UNDER_INDEX And &H4) / 4
  
  DoEvents
Registers(5) = 0
For jj = 0 To 7
 Registers(5) = Val(frmRegDetail.edBitVal(jj + 4)) * (2 ^ (jj)) + Registers(5)
Next jj
frmRegDetail.lblReg5Hex = Hex(Registers(5))
DoEvents
        Select Case OVER_INDEX
           Case 0
              frmRegDetail.lblReg5bits0to3txtline2 = "2.5625 V                                     20.5 mA"
           Case 1
              frmRegDetail.lblReg5bits0to3txtline2 = "2.625 V                                        21.0 mA"
           Case 2
              frmRegDetail.lblReg5bits0to3txtline2 = "2.6875 V                                    21.5 mA"
           Case 3
              frmRegDetail.lblReg5bits0to3txtline2 = "2.75 V                                      22.0 mA"
           Case 4
              frmRegDetail.lblReg5bits0to3txtline2 = "2.8125 V                                       22.5 mA"
           Case 5
              frmRegDetail.lblReg5bits0to3txtline2 = "2.875 V                                     23.0 mA"
           Case 6
              frmRegDetail.lblReg5bits0to3txtline2 = "2.9375 V                                    23.5 mA"
           Case 7
              frmRegDetail.lblReg5bits0to3txtline2 = "3.0 V                                           24.0 mA"
           Case 8
              frmRegDetail.lblReg5bits0to3txtline2 = "3.0625 V                                    24.5 mA"
           Case 9
              frmRegDetail.lblReg5bits0to3txtline2 = "3.125 V                                         25.0 mA"
           Case 10
              frmRegDetail.lblReg5bits0to3txtline2 = "3.1875 V                                    25.5 mA"
           Case 11
              frmRegDetail.lblReg5bits0to3txtline2 = "3.25 V                                          26.0 mA"
           Case 12
              frmRegDetail.lblReg5bits0to3txtline2 = "3.3125 V                                    26.5 mA"
           Case 13
              frmRegDetail.lblReg5bits0to3txtline2 = "3.375 V                                         27.0 mA"
           Case 14
              frmRegDetail.lblReg5bits0to3txtline2 = "3.4374 V                                    27.5 mA"
           Case 15
              frmRegDetail.lblReg5bits0to3txtline2 = "3.5 V                                           28.0 mA"
        End Select
       Select Case UNDER_INDEX
          Case 0
             frmRegDetail.lblReg5bits4to6txtline2 = "475 mV                         3.8 mA"
          Case 1
             frmRegDetail.lblReg5bits4to6txtline2 = "450 mV                         3.6 mA"
          Case 2
             frmRegDetail.lblReg5bits4to6txtline2 = "425 mV                         3.4 mA"
          Case 3
             frmRegDetail.lblReg5bits4to6txtline2 = "400 mV                         3.2 mA"
          Case 4
             frmRegDetail.lblReg5bits4to6txtline2 = "375 mV                         3.0 mA"
          Case 5
             frmRegDetail.lblReg5bits4to6txtline2 = "350 mV                         2.8 mA"
          Case 6
             frmRegDetail.lblReg5bits4to6txtline2 = "325 mV                         2.6 mA"
          Case 7
             frmRegDetail.lblReg5bits4to6txtline2 = "300 mV                         2.4 mA"
       End Select

End Sub

Private Sub Command2_Click()
min_OVER_error = 1000000#
min_UNDER_error = 1000000#
AdjOverTarget = Val(txtTargetOverscaleLimit) - (Val(txtMeasOverScale) - Val(txtTargetOverscaleLimit))
AdjUnderTarget = Val(txtTargetUnderscaleLimit) - (Val(txtMeasUnderScale) - Val(txtTargetUnderscaleLimit))
For jj = 0 To 15
    If Combo1 = "Current" Then
        Error_over = Abs(OverLimit_I_val(jj) - AdjOverTarget)
    Else
        Error_over = Abs(OverLimit_V_val(jj) - AdjOverTarget)
    End If

    If Error_over < min_OVER_error Then
        OVER_INDEX = jj
        min_OVER_error = Error_over
    End If
Next jj
For jj = 0 To 7
    If Combo1 = "Current" Then
        Error_under = Abs(UnderLimit_I_val(jj) - AdjUnderTarget)
    Else
        Error_under = Abs(UnderLimit_V_val(jj) - AdjUnderTarget)
    End If
    If Error_under < min_UNDER_error Then
        UNDER_INDEX = jj
        min_UNDER_error = Error_under
    End If
Next jj
       'IVal = Val(edBitVal(8)) + Val(edBitVal(9)) * 2 + Val(edBitVal(10)) * 4

        'IVal = Val(edBitVal(4)) + Val(edBitVal(5)) * 2 + Val(edBitVal(6)) * 4 + Val(edBitVal(7)) * 8

'MsgBox "V=" + Str(OverLimit_I_val(OVER_INDEX)) + vbCrLf + "c=" + Str(UnderLimit_I_val(UNDER_INDEX))
  frmRegDetail.edBitVal(4) = (OVER_INDEX And &H1)
  frmRegDetail.edBitVal(5) = (OVER_INDEX And &H2) / 2
  frmRegDetail.edBitVal(6) = (OVER_INDEX And &H4) / 4
  frmRegDetail.edBitVal(7) = (OVER_INDEX And &H8) / 8
  
  frmRegDetail.edBitVal(8) = (UNDER_INDEX And &H1)
  frmRegDetail.edBitVal(9) = (UNDER_INDEX And &H2) / 2
  frmRegDetail.edBitVal(10) = (UNDER_INDEX And &H4) / 4
  
  DoEvents
Registers(5) = 0
For jj = 0 To 7
 Registers(5) = Val(frmRegDetail.edBitVal(jj + 4)) * (2 ^ (jj)) + Registers(5)
Next jj
frmRegDetail.lblReg5Hex = Hex(Registers(5))
DoEvents
        Select Case OVER_INDEX
           Case 0
              frmRegDetail.lblReg5bits0to3txtline2 = "2.5625 V                                     20.5 mA"
           Case 1
              frmRegDetail.lblReg5bits0to3txtline2 = "2.625 V                                        21.0 mA"
           Case 2
              frmRegDetail.lblReg5bits0to3txtline2 = "2.6875 V                                    21.5 mA"
           Case 3
              frmRegDetail.lblReg5bits0to3txtline2 = "2.75 V                                      22.0 mA"
           Case 4
              frmRegDetail.lblReg5bits0to3txtline2 = "2.8125 V                                       22.5 mA"
           Case 5
              frmRegDetail.lblReg5bits0to3txtline2 = "2.875 V                                     23.0 mA"
           Case 6
              frmRegDetail.lblReg5bits0to3txtline2 = "2.9375 V                                    23.5 mA"
           Case 7
              frmRegDetail.lblReg5bits0to3txtline2 = "3.0 V                                           24.0 mA"
           Case 8
              frmRegDetail.lblReg5bits0to3txtline2 = "3.0625 V                                    24.5 mA"
           Case 9
              frmRegDetail.lblReg5bits0to3txtline2 = "3.125 V                                         25.0 mA"
           Case 10
              frmRegDetail.lblReg5bits0to3txtline2 = "3.1875 V                                    25.5 mA"
           Case 11
              frmRegDetail.lblReg5bits0to3txtline2 = "3.25 V                                          26.0 mA"
           Case 12
              frmRegDetail.lblReg5bits0to3txtline2 = "3.3125 V                                    26.5 mA"
           Case 13
              frmRegDetail.lblReg5bits0to3txtline2 = "3.375 V                                         27.0 mA"
           Case 14
              frmRegDetail.lblReg5bits0to3txtline2 = "3.4374 V                                    27.5 mA"
           Case 15
              frmRegDetail.lblReg5bits0to3txtline2 = "3.5 V                                           28.0 mA"
        End Select
       Select Case UNDER_INDEX
          Case 0
             frmRegDetail.lblReg5bits4to6txtline2 = "475 mV                         3.8 mA"
          Case 1
             frmRegDetail.lblReg5bits4to6txtline2 = "450 mV                         3.6 mA"
          Case 2
             frmRegDetail.lblReg5bits4to6txtline2 = "425 mV                         3.4 mA"
          Case 3
             frmRegDetail.lblReg5bits4to6txtline2 = "400 mV                         3.2 mA"
          Case 4
             frmRegDetail.lblReg5bits4to6txtline2 = "375 mV                         3.0 mA"
          Case 5
             frmRegDetail.lblReg5bits4to6txtline2 = "350 mV                         2.8 mA"
          Case 6
             frmRegDetail.lblReg5bits4to6txtline2 = "325 mV                         2.6 mA"
          Case 7
             frmRegDetail.lblReg5bits4to6txtline2 = "300 mV                         2.4 mA"
       End Select


End Sub

Private Sub Command3_Click()
Dim RegValues As String
TurnOnDCtoDC
On Error GoTo err
    RegValues = RegisterValuesString(frmRegDetail.chkSumUpdateCheck)
    Call frmMDIMain.WriteAllXTRRegs(RegValues)
    TurnOffDCtoDC
Exit Sub
err:
    err.Source = err.Source & Chr(10) & "frmRegDetail:btnWriteXTR_Click"
    MsgBox err.Description & Chr(10) & err.Source

TurnOffDCtoDC

End Sub

Private Sub Command4_Click()
    Dim RegValues As String
TurnOnDCtoDC
On Error GoTo err
    RegValues = "0000" & RegisterValuesString(frmRegDetail.chkSumUpdateCheck)
    Call frmMDIMain.sendCommand(5, RegValues)
    TurnOffDCtoDC
Exit Sub
err:
    err.Source = err.Source & Chr(10) & "frmRegDetail:btnWriteEEPROM_Click"
    MsgBox err.Description & Chr(10) & err.Source
TurnOffDCtoDC

End Sub

Private Sub Command5_Click()
Dim RegValues As String
TurnOnDCtoDC
On Error GoTo err
    RegValues = RegisterValuesString(frmRegDetail.chkSumUpdateCheck)
    Call frmMDIMain.WriteAllXTRRegs(RegValues)
    TurnOffDCtoDC
Exit Sub
err:
    err.Source = err.Source & Chr(10) & "frmRegDetail:btnWriteXTR_Click"
    MsgBox err.Description & Chr(10) & err.Source

TurnOffDCtoDC

End Sub

Private Sub Command6_Click()
    Dim RegValues As String
TurnOnDCtoDC
On Error GoTo err
    RegValues = "0000" & RegisterValuesString(frmRegDetail.chkSumUpdateCheck)
    Call frmMDIMain.sendCommand(5, RegValues)
    TurnOffDCtoDC
Exit Sub
err:
    err.Source = err.Source & Chr(10) & "frmRegDetail:btnWriteEEPROM_Click"
    MsgBox err.Description & Chr(10) & err.Source
TurnOffDCtoDC

End Sub

Private Sub Form_Load()
Combo1.Clear
Combo1.AddItem "Current"
Combo1.AddItem "Voltage"
'Combo1.Text = "Current"

Combo1.ListIndex = frmRegDetail.Combo1.ListIndex
OverLimit_I_val(0) = 20.5
OverLimit_I_val(1) = 21
OverLimit_I_val(2) = 21.5
OverLimit_I_val(3) = 22
OverLimit_I_val(4) = 22.5
OverLimit_I_val(5) = 23
OverLimit_I_val(6) = 23.5
OverLimit_I_val(7) = 24
OverLimit_I_val(8) = 24.5
OverLimit_I_val(9) = 25
OverLimit_I_val(10) = 25.5
OverLimit_I_val(11) = 26
OverLimit_I_val(12) = 26.5
OverLimit_I_val(13) = 27
OverLimit_I_val(14) = 27.5
OverLimit_I_val(15) = 28

OverLimit_V_val(0) = 2.5625
OverLimit_V_val(1) = 2.625
OverLimit_V_val(2) = 2.6875
OverLimit_V_val(3) = 2.75
OverLimit_V_val(4) = 2.8125
OverLimit_V_val(5) = 2.875
OverLimit_V_val(6) = 2.9375
OverLimit_V_val(7) = 3#
OverLimit_V_val(8) = 3.0625
OverLimit_V_val(9) = 3.125
OverLimit_V_val(10) = 3.1875
OverLimit_V_val(11) = 3.25
OverLimit_V_val(12) = 3.3125
OverLimit_V_val(13) = 3.375
OverLimit_V_val(14) = 3.4374
OverLimit_V_val(15) = 3.5


UnderLimit_I_val(0) = 3.8
UnderLimit_I_val(1) = 3.6
UnderLimit_I_val(2) = 3.4
UnderLimit_I_val(3) = 3.2
UnderLimit_I_val(4) = 3#
UnderLimit_I_val(5) = 2.8
UnderLimit_I_val(6) = 2.6
UnderLimit_I_val(7) = 2.4

UnderLimit_V_val(0) = 0.475
UnderLimit_V_val(1) = 0.45
UnderLimit_V_val(2) = 0.425
UnderLimit_V_val(3) = 0.4
UnderLimit_V_val(4) = 0.375
UnderLimit_V_val(5) = 0.35
UnderLimit_V_val(6) = 0.325
UnderLimit_V_val(7) = 0.3



End Sub
