Attribute VB_Name = "globals"
Option Explicit
Public Registers(15) As Integer
Public RTD_Base As Single
Public RTDMin As Single 'temp
Public RTDMax As Single 'temp
Public RTDMid As Single
Public RZ(1 To 5) As Single
Public ResRlin As Long
Public ResRset As Long
Public ResRvi As Long
Public RegisterCaption As String
Public CurrentRegNum As Integer
Public CurrentCommPort As Integer
Public OldCommPort As Integer
Public MaxTemp As Single
Public MinTemp As Single
Public vMaxTemp As Single
Public vMinTemp As Single
Public iMaxTemp As Single
Public iMinTemp As Single
Public Iset As Single
Public A(7) As Single
Public bv As Single
Private Const hexdigits As String = "0123456789ABCDEF"
Public Const Vref As Single = 1.193
Public PGAGain As Integer
Public RzChosen As Integer
Public Glin As Single
Public IAref As Single, IBref As Single, dIref As Single, dIzero As Single
Public RAz As Single, dRz As Single
Public GAlin As Single
Public Cal_Step As Integer
Public Old_reg5 As Integer
Public AK As Single '= 0.0039083
Public BK As Single '= '-0.0000005775
Public CK As Single '= -4.1835E-12
Public Viso_enable
Public FindRes_RTD(5), FindRes_T_Cold(5), FindRes_T_Hot(5), FindRes_Rvi
Public FindRes_a(5), FindRes_b(5), FindRes_c(5), FindRes_Rz(5), FindRes_Imax_Vmax, FindRes_Imin_Vmin
Public FindRes_Rset, FindRes_Rlin, FindRes_Rrcm, FindRes_RTD_Cold(5), FindRes_RTD_Mid(5), FindRes_RTD_Hot(5), FindRes_Bv(5)
Public FindRes_Glin(5), FindRes_RsetMin(5), FindRes_RsetMax(5), FindRes_RlinMax(5), FindRes_GainTyp(5)
Public FindRes_IrefTyp(5), FindRes_VdifTyp(5), FindRes_LinDacRes(5), FindRes_LinDacResPct(5), FindRes_Vcm_Min(5)
Public FindRes_Vcm_Max(5), Wait_For_InitUpdate, made_change
Public Answer$, error_flag, LinDacResMaxPct, VcmMax, VcmMin
Public Max_Index, Min_Index
Public WorstCaseLinCh, WorstCaseVcmMinCh, WorstCaseVcmMaxCh, ErrorMsg, xi
Public LastMonthChecked, LastYearChecked
Public Path As String
Public OverLimit_I_val(15) As Double
Public OverLimit_V_val(15) As Double
Public UnderLimit_I_val(15) As Double
Public UnderLimit_V_val(15) As Double
Public user_defined_mux As Boolean


Public Function DisplayScientific(ByVal Inval As Double, ByVal NumFrmt As String) As String
Dim x, y, mant, xxx, yyy

If Inval <> 0 Then
x = Log(Abs(Inval)) / Log(10)
If x < 0 Then
y = -Int(Abs(x) + 1)
Else
y = Int(x)
End If
mant = Inval / (10 ^ y)
    If y > 0 Then
    yyy = Format(mant, NumFrmt)
    xxx = Int(Abs(Val(yyy)))
        If xxx >= 10 Then
            mant = mant / 10
            y = y + 1
        End If
        DisplayScientific = Format(mant, NumFrmt) + "E+" + Right(Str(y), Len(Str(y)) - 1)
    Else
        DisplayScientific = Format(mant, NumFrmt) + "E" + Str(y)
    End If
End If
End Function

Public Sub ReadFindResistorScrn()
Dim i
For i = 0 To 4
FindRes_RTD(i) = Val(frmRegDetail.Text1(i))
Next i

For i = 0 To 4
FindRes_T_Cold(i) = Val(frmRegDetail.Text2(i))
Next i

For i = 0 To 4
FindRes_T_Hot(i) = Val(frmRegDetail.Text3(i))
Next i

For i = 0 To 4
FindRes_a(i) = Val(frmRegDetail.Text4(i))
Next i

For i = 0 To 4
FindRes_b(i) = Val(frmRegDetail.Text5(i))
Next i

For i = 0 To 4
FindRes_c(i) = Val(frmRegDetail.Text6(i))
Next i

For i = 0 To 4
FindRes_Rz(i) = Val(frmRegDetail.Text11(i))
Next i

FindRes_Rvi = Val(frmRegDetail.Text7)
If frmRegDetail.Combo1 = "Voltage" Then
    FindRes_Imax_Vmax = Val(frmRegDetail.Text8)
    FindRes_Imin_Vmin = Val(frmRegDetail.Text9)
Else
    FindRes_Imax_Vmax = Val(frmRegDetail.Text8) / 1000
    FindRes_Imin_Vmin = Val(frmRegDetail.Text9) / 1000
End If



End Sub

Public Sub TurnOnDCtoDC()
Call pause(0.1)
frmMDIMain.pCommPort.RTSEnable = False            'turnes on the dc - to - dc converter
Call pause(0.1)

End Sub
Public Sub TurnOffDCtoDC()
 
    Call pause(0.05)
    If Viso_enable = False Then frmMDIMain.pCommPort.RTSEnable = True  'turnes off the dc - to - dc converter
    Call pause(0.05)

End Sub
Public Function AddZero(Num As Integer) As String
Dim NumStr As String
NumStr = Hex(Num)
AddZero = Right$("00" & NumStr, 2)
End Function

Public Sub InitializeData()

Dim i As Integer
On Error GoTo err1:

For i = 0 To 14
   Registers(i) = 0
Next i
Registers(15) = 255

Open "xtr108_config.txt" For Input As #1
Input #1, ResRlin
Input #1, ResRset
Input #1, ResRvi
Input #1, RZ(1)
Input #1, RZ(2)
Input #1, RZ(3)
Input #1, RZ(4)
Input #1, RZ(5)
Input #1, RTD_Base
Input #1, AK
Input #1, BK
Input #1, CK
Input #1, LastMonthChecked
Input #1, LastYearChecked
Input #1, Path
Close #1

Exit Sub
err1:

RTD_Base = 100
For i = 1 To 5
    RZ(i) = 80 + (i * 10)
Next i
ResRset = 12100
ResRlin = 15800
ResRvi = 6340
AK = 0.0039083
BK = -0.0000005775
CK = -4.1835E-12

Close #1
 
End Sub
Public Sub InitializeFindResistors()
Dim i As Integer
On Error GoTo err1:
Wait_For_InitUpdate = 1

'For i = 0 To 14
'   Registers(i) = 0
'Next i
'Registers(15) = 255

Open "xtr108_config_FindRes.txt" For Input As #1

For i = 0 To 4
Input #1, FindRes_RTD(i)
Next i

For i = 0 To 4
Input #1, FindRes_T_Cold(i)
Next i

For i = 0 To 4
Input #1, FindRes_T_Hot(i)
Next i




For i = 0 To 4
Input #1, FindRes_a(i)
Next i

For i = 0 To 4
Input #1, FindRes_b(i)
Next i

For i = 0 To 4
Input #1, FindRes_c(i)
Next i

For i = 0 To 4
Input #1, FindRes_Rz(i)
Next i

Input #1, FindRes_Rvi
Input #1, FindRes_Imax_Vmax
Input #1, FindRes_Imin_Vmin

Input #1, FindRes_Rset
Input #1, FindRes_Rlin
Input #1, FindRes_Rrcm


Close #1

'FindRes_Rset = 0
'FindRes_Rlin = 0
'FindRes_Rrcm = 0
UpdateDisplayFindResistors
Wait_For_InitUpdate = 0
made_change = 0
Exit Sub
err1:

Call DefaultFindResistors
UpdateDisplayFindResistors
Wait_For_InitUpdate = 0
made_change = 0
Close #1
 

End Sub
Public Sub DefaultFindResistors()
'this is only for the Find Resistors tab
FindRes_RTD(0) = 100
FindRes_RTD(1) = 100
FindRes_RTD(2) = 100
FindRes_RTD(3) = 100
FindRes_RTD(4) = 100

FindRes_T_Cold(0) = -200
FindRes_T_Cold(1) = 0
FindRes_T_Cold(2) = 0
FindRes_T_Cold(3) = -55
FindRes_T_Cold(4) = 25

FindRes_T_Hot(0) = 850
FindRes_T_Hot(1) = 400
FindRes_T_Hot(2) = 125
FindRes_T_Hot(3) = 125
FindRes_T_Hot(4) = 75

FindRes_a(0) = 0.0039083
FindRes_a(1) = 0.0039083
FindRes_a(2) = 0.0039083
FindRes_a(3) = 0.0039083
FindRes_a(4) = 0.0039083

FindRes_b(0) = -0.0000005775
FindRes_b(1) = -0.0000005775
FindRes_b(2) = -0.0000005775
FindRes_b(3) = -0.0000005775
FindRes_b(4) = -0.0000005775

FindRes_c(0) = -4.1835E-12
FindRes_c(1) = -4.1835E-12
FindRes_c(2) = -4.1835E-12
FindRes_c(3) = -4.1835E-12
FindRes_c(4) = -4.1835E-12

FindRes_Rz(0) = 100
FindRes_Rz(1) = 200
FindRes_Rz(2) = 300
FindRes_Rz(3) = 400
FindRes_Rz(4) = 500

FindRes_Rvi = 6340
FindRes_Imax_Vmax = 0.02
FindRes_Imin_Vmin = 0.004

FindRes_Rset = 0
FindRes_Rlin = 0
FindRes_Rrcm = 0



End Sub

Public Sub SaveFindResistorsDefault()
Dim i As Integer

'this is only for the Find Resistors tab
Open "xtr108_config_FindRes.txt" For Output As #1

For i = 0 To 4
Write #1, FindRes_RTD(i)
Next i

For i = 0 To 4
Write #1, FindRes_T_Cold(i)
Next i

For i = 0 To 4
Write #1, FindRes_T_Hot(i)
Next i

For i = 0 To 4
Write #1, FindRes_a(i)
Next i

For i = 0 To 4
Write #1, FindRes_b(i)
Next i

For i = 0 To 4
Write #1, FindRes_c(i)
Next i

For i = 0 To 4
Write #1, FindRes_Rz(i)
Next i


Write #1, FindRes_Rvi
Write #1, FindRes_Imax_Vmax
Write #1, FindRes_Imin_Vmin

Write #1, FindRes_Rset
Write #1, FindRes_Rlin
Write #1, FindRes_Rrcm



'FindRes_Rvi = 6340
'FindRes_Imax_Vmax = 0.02
'FindRes_Imin_Vmin = 0.004

'FindRes_Rset = 0
'FindRes_Rlin = 0
'FindRes_Rrcm = 0



End Sub

Public Sub UpdateDisplayFindResistors()
frmRegDetail.Text1(0) = Str(FindRes_RTD(0))
frmRegDetail.Text1(1) = Str(FindRes_RTD(1))
frmRegDetail.Text1(2) = Str(FindRes_RTD(2))
frmRegDetail.Text1(3) = Str(FindRes_RTD(3))
frmRegDetail.Text1(4) = Str(FindRes_RTD(4))

frmRegDetail.Text2(0) = Str(FindRes_T_Cold(0))
frmRegDetail.Text2(1) = Str(FindRes_T_Cold(1))
frmRegDetail.Text2(2) = Str(FindRes_T_Cold(2))
frmRegDetail.Text2(3) = Str(FindRes_T_Cold(3))
frmRegDetail.Text2(4) = Str(FindRes_T_Cold(4))

frmRegDetail.Text3(0) = Str(FindRes_T_Hot(0))
frmRegDetail.Text3(1) = Str(FindRes_T_Hot(1))
frmRegDetail.Text3(2) = Str(FindRes_T_Hot(2))
frmRegDetail.Text3(3) = Str(FindRes_T_Hot(3))
frmRegDetail.Text3(4) = Str(FindRes_T_Hot(4))

frmRegDetail.Text4(0) = DisplayScientific(FindRes_a(0), "#.0000")
frmRegDetail.Text4(1) = DisplayScientific(FindRes_a(1), "#.0000")
frmRegDetail.Text4(2) = DisplayScientific(FindRes_a(2), "#.0000")
frmRegDetail.Text4(3) = DisplayScientific(FindRes_a(3), "#.0000")
frmRegDetail.Text4(4) = DisplayScientific(FindRes_a(4), "#.0000")

frmRegDetail.Text5(0) = DisplayScientific(FindRes_b(0), "#.0000")
frmRegDetail.Text5(1) = DisplayScientific(FindRes_b(1), "#.0000")
frmRegDetail.Text5(2) = DisplayScientific(FindRes_b(2), "#.0000")
frmRegDetail.Text5(3) = DisplayScientific(FindRes_b(3), "#.0000")
frmRegDetail.Text5(4) = DisplayScientific(FindRes_b(4), "#.0000")

frmRegDetail.Text6(0) = DisplayScientific(FindRes_c(0), "#.0000")
frmRegDetail.Text6(1) = DisplayScientific(FindRes_c(1), "#.0000")
frmRegDetail.Text6(2) = DisplayScientific(FindRes_c(2), "#.0000")
frmRegDetail.Text6(3) = DisplayScientific(FindRes_c(3), "#.0000")
frmRegDetail.Text6(4) = DisplayScientific(FindRes_c(4), "#.0000")

frmRegDetail.Text11(0) = Str(FindRes_Rz(0))
frmRegDetail.Text11(1) = Str(FindRes_Rz(1))
frmRegDetail.Text11(2) = Str(FindRes_Rz(2))
frmRegDetail.Text11(3) = Str(FindRes_Rz(3))
frmRegDetail.Text11(4) = Str(FindRes_Rz(4))


frmRegDetail.Text7 = Str(FindRes_Rvi)
If frmRegDetail.Combo1 = "Voltage" Then
    frmRegDetail.Text8 = Str(FindRes_Imax_Vmax)
    frmRegDetail.Text9 = Str(FindRes_Imin_Vmin)
Else
    frmRegDetail.Text8 = Str(FindRes_Imax_Vmax) * 1000
    frmRegDetail.Text9 = Str(FindRes_Imin_Vmin) * 1000
End If
frmRegDetail.Text12 = Str(FindRes_Rset)
frmRegDetail.Text13 = Str(FindRes_Rlin)
frmRegDetail.Text14 = Str(FindRes_Rrcm)

End Sub
Public Sub UpdateRegistersAllForms()
Dim i As Integer
Rem Update the Summary Tab

frmRegDetail.txtSumRTD = Trim(Str(RTDMin))
frmRegDetail.txtSumRz(1) = Trim(Str(RZ(1)))
frmRegDetail.txtSumRz(2) = Trim(Str(RZ(2)))
frmRegDetail.txtSumRz(3) = Trim(Str(RZ(3)))
frmRegDetail.txtSumRz(4) = Trim(Str(RZ(4)))
frmRegDetail.txtSumRz(5) = Trim(Str(RZ(5)))
frmRegDetail.txtRLin(0) = Trim(Str(ResRlin))
frmRegDetail.txtRvi(0) = Trim(Str(ResRvi))
frmRegDetail.txtRSet(0) = Trim(Str(ResRset))
frmRegDetail.lblSumReg3Val = AddZero(Registers(3))

Rem update the Calibration Tab

frmRegDetail.txtCalRTD = Trim(Str(RTDMin))
frmRegDetail.txtCalRz(1) = Trim(Str(RZ(1)))
frmRegDetail.txtCalRz(2) = Trim(Str(RZ(2)))
frmRegDetail.txtCalRz(3) = Trim(Str(RZ(3)))
frmRegDetail.txtCalRz(4) = Trim(Str(RZ(4)))
frmRegDetail.txtCalRz(5) = Trim(Str(RZ(5)))
frmRegDetail.txtRLin(1) = Trim(Str(ResRlin))
frmRegDetail.txtRvi(1) = Trim(Str(ResRvi))
frmRegDetail.txtRSet(1) = Trim(Str(ResRset))
frmRegDetail.lblCalReg3Val = AddZero(Registers(3))

'Update Register Sections
For i = 5 To 15
frmRegDetail.txtCalReg(i) = AddZero(Registers(i))
frmRegDetail.txtSumReg(i) = AddZero(Registers(i))
Next i

'Update labels on last page
frmRegDetail.lbxRegisterHex.List(0) = AddZero(Registers(10))
frmRegDetail.lbxRegisterBin.List(0) = Display8Bit(Registers(10))
frmRegDetail.lbxRegisterHex.List(1) = AddZero(Registers(11))
frmRegDetail.lbxRegisterBin.List(1) = Display8Bit(Registers(11))
frmRegDetail.lbxRegisterHex.List(2) = AddZero(Registers(12))
frmRegDetail.lbxRegisterBin.List(2) = Display8Bit(Registers(12))
frmRegDetail.lbxRegisterHex.List(3) = AddZero(Registers(13))
frmRegDetail.lbxRegisterBin.List(3) = Display8Bit(Registers(13))
frmRegDetail.lbxRegisterHex.List(4) = AddZero(Registers(14))
frmRegDetail.lbxRegisterBin.List(4) = Display8Bit(Registers(14))
frmRegDetail.lbxRegisterHex.List(5) = AddZero(Registers(15))
frmRegDetail.lbxRegisterBin.List(5) = Display8Bit(Registers(15))
frmRegDetail.chkDisableReadback(0) = Registers(4) And 1
frmRegDetail.chkDisableReadback(1) = Registers(4) And 1

End Sub

            ' procedure to return a string with the
            ' binary value of the argument
Public Function DisplayBinary(inByte As Integer) As String
'    If inByte = 0 Then
'        DisplayBinary = 0
'    Else
'        DisplayBinary = DisplayBinary(Fix(inByte / 2#)) & IIf(inByte Mod 2 = 1, "1", "0")
'    End If
Dim i As Integer
For i = 0 To 7
    If inByte And (2 ^ i) Then
        DisplayBinary = "1" & DisplayBinary
    Else
        DisplayBinary = "0" & DisplayBinary
    End If
Next i

End Function

            ' displays the binary string of 8 LSBs of the argument
Public Function Display8Bit(inByte As Integer) As String
    Display8Bit = DisplayBinary(inByte)
    If Len(Display8Bit) > 8 Then
        Display8Bit = Right(Display8Bit, 8)
    Else
        While Len(Display8Bit) < 8
            Display8Bit = "0" & Display8Bit
        Wend
    End If
End Function
'*************************************************************
'           ValidateResistor
'               Limits Resistor Values to 6 characters and
'               Returns the Value of the Resistor
'*************************************************************
Public Function ValidateResistor(Instring As String) As Long
     If Len(Instring) <= 6 Then
         ValidateResistor = Val(Instring)
     Else
         ValidateResistor = Val(Left(Instring, 6))
     End If

End Function

Public Function BinStr2Val(inStrBin As String) As Variant
    If Len(inStrBin) = 0 Then
        BinStr2Val = 0
    Else
        Select Case Right(inStrBin, 1)       'looking at LSB
        Case "1"                'if "1" - return 2*MSBs + 1
            BinStr2Val = 2 * BinStr2Val(Left(inStrBin, Len(inStrBin) - 1)) + 1
        Case "0"
            BinStr2Val = 2 * BinStr2Val(Left(inStrBin, Len(inStrBin) - 1))
        Case Else               ' if not "1" nor "0" = return zero
            BinStr2Val = 0
        End Select
    End If
End Function
'***************************************************************
'           WriteRegister - Write register from 2 char hex value
'               Registers 6 (PGA Gain), 8,9(Iref and Voltage Selection)
'                       Have bits masked off
'               Registers 10,11,12,13 are 2's Complement
'***************************************************************
Public Sub WriteRegister(regNum As Integer, TxtVal As String)
On Error GoTo err
    Select Case regNum
    Case 0, 1, 2, 3, 4, 5, 7, 14, 15:
        Registers(regNum) = Val("&H" + TxtVal)
    Case 6:
        Registers(regNum) = Val("&H" + TxtVal)
        Registers(6) = Registers(6) And Val("&H07")
    Case 8, 9:
    Dim NewVal As String
        If (Val("&H" & TxtVal) And &H70) / 16 > 5 Then
            NewVal = "0"
        Else
            NewVal = Left(TxtVal, 1)
        End If
        If (Val("&H" & TxtVal) And &H7) > 5 Then
            NewVal = NewVal & "0"
        Else
            NewVal = NewVal & Right(TxtVal, 1)
        End If
        Registers(regNum) = Val("&H" + NewVal)
        Registers(regNum) = Registers(regNum) And Val("&H77")
    Case 10, 11, 12, 13:
        Registers(regNum) = TwosCompliment(Val("&H" + TxtVal))
    End Select
Exit Sub
err:
    err.Source = err.Source & Chr(10) & "globals.WriteRegister"
    err.Raise err.Number
End Sub

Public Function TwosCompliment(Inval As Byte) As Integer
    If (Inval > 127) Then     'processing 2's compliment value
        TwosCompliment = Inval - 256
    Else
        TwosCompliment = Inval
    End If
End Function
Public Function RTD_Value(xRo, xA, xB, xC, xT)
If xRo <> 0 Then 'skip channels with xRo=0
If (xT < -200) Or (xT > 850) Then
ErrorMsg = ErrorMsg + "Error in RTD Temperature Range.  Channel= " + Str(xi + 1) + vbCrLf
error_flag = 1
End If

If (xT > 0) Then
    RTD_Value = xRo * (1 + xA * xT + xB * xT ^ 2)
Else
    RTD_Value = xRo * (1 + xA * xT + xB * xT ^ 2 + xC * (xT ^ 3) * (xT - 100))
End If
'IF(F2>0,E2*(1+B2*F2+C2*F2^2),E2*(1+B2*F2+C2*F2^2+D2*(F2^3)*(F2-100)))
End If
End Function
Public Sub UpdateFindResistors()
Dim MaxRsetMin, MinRsetMax, Iref_min, Iref_max

For xi = 0 To 4
FindRes_RTD_Cold(xi) = RTD_Value(FindRes_RTD(xi), FindRes_a(xi), FindRes_b(xi), FindRes_c(xi), FindRes_T_Cold(xi))
Next xi

For xi = 0 To 4
FindRes_RTD_Mid(xi) = RTD_Value(FindRes_RTD(xi), FindRes_a(xi), FindRes_b(xi), FindRes_c(xi), (FindRes_T_Cold(xi) + FindRes_T_Hot(xi)) / 2)
Next xi

For xi = 0 To 4
FindRes_RTD_Hot(xi) = RTD_Value(FindRes_RTD(xi), FindRes_a(xi), FindRes_b(xi), FindRes_c(xi), FindRes_T_Hot(xi))
Next xi

For xi = 0 To 4
If FindRes_RTD(xi) <> 0 Then
FindRes_Bv(xi) = (FindRes_RTD_Mid(xi) - (FindRes_RTD_Hot(xi) + FindRes_RTD_Cold(xi)) / 2) / (FindRes_RTD_Hot(xi) - FindRes_RTD_Cold(xi))
End If
Next xi
'=(J2-(K2+I2)/2)/(K2-I2)

For xi = 0 To 4
If FindRes_RTD(xi) <> 0 Then
FindRes_Rz(xi) = Find_A_Standard_Resistor(FindRes_RTD_Cold(xi))
Else
FindRes_Rz(xi) = 0
End If
Next xi

For xi = 0 To 4
If FindRes_RTD(xi) <> 0 Then
FindRes_Glin(xi) = (2 * FindRes_Bv(xi) / ((0.5 + FindRes_Bv(xi)) * FindRes_RTD_Hot(xi) - (0.5 - FindRes_Bv(xi)) * FindRes_RTD_Cold(xi) - 2 * FindRes_Bv(xi) * FindRes_Rz(xi)))
End If
Next xi

'=(2*L2/((0.5+L2)*K2-(0.5-L2)*I2-2*L2*Q2))

For xi = 0 To 4
If FindRes_RTD(xi) <> 0 Then
FindRes_RsetMin(xi) = Find_A_Standard_Resistor(FindRsetMin(Vref, FindRes_Imax_Vmax, FindRes_Imin_Vmin, FindRes_RTD_Hot(xi), FindRes_RTD_Cold(xi), FindRes_Rvi))
End If
Next xi

For xi = 0 To 4
If FindRes_RTD(xi) <> 0 Then
FindRes_RsetMax(xi) = Find_A_Standard_Resistor(FindRsetMax(Vref, FindRes_Imax_Vmax, FindRes_Imin_Vmin, FindRes_RTD_Hot(xi), FindRes_RTD_Cold(xi), FindRes_Rvi))
End If
Next xi

For xi = 0 To 4
If FindRes_RTD(xi) <> 0 Then
FindRes_RlinMax(xi) = 16 / FindRes_Glin(xi)
End If
Next xi

FindRes_Rlin = Find_A_Standard_Resistor(Minimum_of_Array(FindRes_RlinMax) * 0.85)

MaxRsetMin = Maximum_of_Array(FindRes_RsetMin)
MinRsetMax = Minimum_of_Array(FindRes_RsetMax)
If MaxRsetMin < MinRsetMax Then
    FindRes_Rset = MaxRsetMin
Else
    FindRes_Rset = -999
End If

Iref_min = (5 * Vref / FindRes_Rset) + (-Vref / FindRes_Rset) * (128 / 64) + (-Vref / FindRes_Rset) * (128 / 1024)
Iref_max = (5 * Vref / FindRes_Rset) + (Vref / FindRes_Rset) * (128 / 64) + (Vref / FindRes_Rset) * (128 / 1024)

For xi = 0 To 4
If FindRes_RTD(xi) <> 0 Then
FindRes_GainTyp(xi) = FindGain(Vref, FindRes_Rset, (Iref_min + Iref_max) / 2, FindRes_Imax_Vmax, FindRes_Imin_Vmin, FindRes_RTD_Hot(xi), FindRes_RTD_Cold(xi), FindRes_Rvi)
End If
Next xi

For xi = 0 To 4
If FindRes_RTD(xi) <> 0 Then
    If frmRegDetail.Combo1 = "Voltage" Then
        FindRes_IrefTyp(xi) = (FindRes_Imax_Vmax - FindRes_Imin_Vmin) / ((FindRes_RTD_Hot(xi) - FindRes_RTD_Cold(xi)) * FindRes_GainTyp(xi))
    Else
        FindRes_IrefTyp(xi) = (FindRes_Imax_Vmax - FindRes_Imin_Vmin) * FindRes_Rvi / ((FindRes_RTD_Hot(xi) - FindRes_RTD_Cold(xi)) * FindRes_GainTyp(xi) * 50)
    End If
End If
Next xi
FindRes_Rrcm = Find_A_Standard_Resistor(0.4 / (2 * Minimum_of_Array(FindRes_IrefTyp)))

For xi = 0 To 4
If FindRes_RTD(xi) <> 0 Then
FindRes_VdifTyp(xi) = FindRes_IrefTyp(xi) * (FindRes_RTD_Hot(xi) - FindRes_RTD_Cold(xi))
End If
Next xi
'=S2*(K2-I2)
For xi = 0 To 4
    If FindRes_RTD(xi) <> 0 Then
        FindRes_LinDacRes(xi) = FindRes_VdifTyp(xi) / (16 * FindRes_Rlin)
    End If
Next xi
'=T2/(16*Rlin)

For xi = 0 To 4
    If FindRes_RTD(xi) <> 0 Then
        If frmRegDetail.Combo1 = "Voltage" Then
            FindRes_LinDacResPct(xi) = 100 * (FindRes_LinDacRes(xi) * (FindRes_RTD_Hot(xi) - FindRes_RTD_Cold(xi)) * FindRes_GainTyp(xi)) / (FindRes_Imax_Vmax - FindRes_Imin_Vmin)
        Else
            FindRes_LinDacResPct(xi) = 100 * (FindRes_LinDacRes(xi) * (FindRes_RTD_Hot(xi) - FindRes_RTD_Cold(xi)) * FindRes_GainTyp(xi) * 50 / FindRes_Rvi) / (FindRes_Imax_Vmax - FindRes_Imin_Vmin)
        End If
    End If
Next xi

LinDacResMaxPct = Maximum_of_Array(FindRes_LinDacResPct)
WorstCaseLinCh = Max_Index

For xi = 0 To 4
    If FindRes_RTD(xi) <> 0 Then
        FindRes_Vcm_Min(xi) = FindRes_IrefTyp(xi) * 2 * FindRes_Rrcm
    End If
Next xi

VcmMin = Minimum_of_Array(FindRes_Vcm_Min)
WorstCaseVcmMinCh = Min_Index

For xi = 0 To 4
    If FindRes_RTD(xi) <> 0 Then
        FindRes_Vcm_Max(xi) = 2 * FindRes_IrefTyp(xi) * FindRes_Rrcm + FindRes_IrefTyp(xi) * FindRes_RTD_Hot(xi)
    End If
Next xi
VcmMax = Maximum_of_Array(FindRes_Vcm_Max)
WorstCaseVcmMaxCh = Max_Index

'=2*S2*Rcm+S2*K2
'=FindGain(Vref, Rset, (Iref_min+Iref_max)/2, Imax, Imin, K2, I2, Rvi)
'=Find_A_Standard_Resistor(FindRsetMin(Vref, Imax, Imin, K2, I2, Rvi))
End Sub
Public Function DisplayEngineering(ByVal Inval As Double) As String
'from pga309
    Dim Suffix As String
    Dim Sign As Integer
    Sign = Sgn(Inval)
    Inval = Abs(Inval)
    If Inval > 1000000000000# Then
        Suffix = "T"
        Inval = Inval / 1000000000000#
    ElseIf Inval > 1000000000# Then
        Suffix = "G"
        Inval = Inval / 1000000000#
    ElseIf Inval > 1000000# Then
        Suffix = "M"
        Inval = Inval / 1000000#
    ElseIf Inval > 1000# Then
            Suffix = "K"
        Inval = Inval / 1000#
    ElseIf Inval > 1 Then
        Suffix = " "
    ElseIf Inval > 0.001 Then
        Suffix = "m"
        Inval = Inval / 0.001
    ElseIf Inval > 0.000001 Then
        Suffix = "u"
        Inval = Inval / 0.000001
    ElseIf Inval > 0.000000001 Then
        Suffix = "n"
        Inval = Inval / 0.000000001
    ElseIf Inval > 0.000000000001 Then
        Suffix = "p"
        Inval = Inval / 0.000000000001
    ElseIf Inval > 0.000000000000001 Then
        Suffix = "f"
        Inval = Inval / 0.000000000000001
    End If
    DisplayEngineering = Format(Sign * Inval, "##0.000") & Suffix
End Function
Public Function EngineeringVal(inStrDec As String) As Double
    Dim i As Integer
    Dim ch As String * 1
    Dim strNum As String
    If inStrDec = "" Then   'return 0 if the string is empty
        EngineeringVal = 0
        Exit Function
    End If
    strNum = ""
    i = 0
    For i = 1 To Len(inStrDec)
        ch = Mid(inStrDec, i, 1)
        If (ch >= "0" And ch <= "9") Or ch = "." Or ch = "," _
            Or UCase(ch) = "E" Or ch = "+" Or ch = "-" Then
            strNum = strNum & ch
        Else
            Exit For    'break the loop if the char is not a digit
        End If
    Next i
    If strNum = "" Then     'return 0 if the string is empty
        EngineeringVal = 0
        Exit Function
    End If
    EngineeringVal = CDbl(strNum)
    If i > Len(inStrDec) Then Exit Function 'exit if we reached
                                        'the end of the string
    Select Case ch
    Case "K", "k"
        EngineeringVal = EngineeringVal * 1000#
    Case "M"
        EngineeringVal = EngineeringVal * 1000000#
    Case "G", "t"
        EngineeringVal = EngineeringVal * 1000000000#
    Case "T", "t"
        EngineeringVal = EngineeringVal * 1000000000000#
    Case "m"
        EngineeringVal = EngineeringVal * 0.001
    Case "U", "u"
        EngineeringVal = EngineeringVal * 0.000001
    Case "N", "n"
        EngineeringVal = EngineeringVal * 0.000000001
    Case "P", "p"
        EngineeringVal = EngineeringVal * 0.000000000001
    Case "F", "f"
        EngineeringVal = EngineeringVal * 0.000000000000001
    End Select
End Function


Public Function toASCII(ByVal value As Integer) As String
On Error GoTo err
    value = value And 255      'Only look at lower byte
    toASCII = Mid$(hexdigits, Int(1 + (value / 16)), 1)
    toASCII = toASCII & Mid$(hexdigits, 1 + (value Mod 16), 1)
Exit Function
err:
    err.Source = err.Source & Chr(10) & "Globals:toASCII"
    err.Raise err.Number
End Function
Public Function toHex(ASCIIValue As String) As Byte
Dim Answer As Byte
On Error GoTo err
    If Len(ASCIIValue) = 1 Then ASCIIValue = "0" & ASCIIValue
    If Len(ASCIIValue) > 2 Then ASCIIValue = Right$(ASCIIValue, 2)
    Answer = InStr(1, hexdigits, Right$(ASCIIValue, 1), vbTextCompare) - 1
    Answer = Answer + (16 * (InStr(1, hexdigits, Left$(ASCIIValue, 1), vbTextCompare) - 1))
    toHex = Answer
Exit Function
err:
    err.Source = err.Source & Chr(10) & "Globals:toHex"
    err.Raise err.Number
End Function
Public Function GenerateCheckChars(Instring As String) As String
Dim i As Integer, check As Integer
On Error GoTo err
  For i = 1 To Len(Instring) Step 2
    check = check + toHex(Mid$(Instring, i, 2))
  Next i
  GenerateCheckChars = toASCII(check)
Exit Function
err:
    err.Source = err.Source & Chr(10) & "Globals:GenerateCheckChars"
    err.Raise err.Number
End Function
'******************************************************************
'       RegisterValuesString() as string
'           Create a string from all of the register values
'******************************************************************
Public Function RegisterValuesString(calcChecksum As Boolean) As String
Dim i As Integer
Dim MyString As String
On Error GoTo err
    If calcChecksum Then
        updateCheckRegister
        frmRegDetail.UpdateEverything
    End If
    For i = 0 To 15
        MyString = MyString & toASCII(Registers(i))
    Next i
    RegisterValuesString = MyString
Exit Function
err:
    err.Source = err.Source & Chr(10) & "Globals:RegisterValuesString"
    err.Raise err.Number
End Function
'*******************************************************************
'           UpdateCheckRegister
'               Calculates the check bits register
'
'*******************************************************************
Public Sub updateCheckRegister()
On Error GoTo err
    Dim i As Integer
    Dim sum As Integer
    For i = 4 To 14
        sum = sum + (Registers(i) And 255)
        If sum > 255 Then sum = (sum And 255) + 1
    Next i
    Registers(15) = 255 - sum
Exit Sub
err:
    err.Source = err.Source & Chr(10) & "Globals:UpdateCheckRegister"
    err.Raise err.Number
End Sub

'*************************************************************
'   Verify Message
'   1. Verify Check Bits
'   2. Verify length
'   3. Verify the FF is there
'
'**************************************************************
Public Function verifyMessage(Message As String) As Boolean
    Dim ShortMessage As String
    ShortMessage = Left$(Message, Len(Message) - 2)
    verifyMessage = (GenerateCheckChars(ShortMessage) = Right$(Message, 2)) And _
        (toHex(Left$(Message, 2)) = (Len(Message) / 2) + 2) And _
        (Mid$(Message, 3, 2) = "FF")
End Function
'******************************************************************
'           BitIndexToRegister(index as integer) as integer
'               Translates the bit indexes for the register tabs to their
'               register numbers
'*********************************************************************
Public Function BitIndexToRegister(Index As Integer) As Integer
Select Case Index
    Case 2
        BitIndexToRegister = 0
    Case 3
        BitIndexToRegister = 4
    Case 4, 5, 6, 7, 8, 9, 10, 11
        BitIndexToRegister = 5

    Case 12, 13, 14
       BitIndexToRegister = 6
    
    Case 15, 16, 17, 18, 19, 20, 21, 22
        BitIndexToRegister = 7
          
    Case 23, 24, 25, 26, 27, 28
       BitIndexToRegister = 8
          
    Case 29, 30, 31, 32, 33, 34
       BitIndexToRegister = 9
    End Select
End Function
'******************************************************************
'           BitIndexToBit(index as integer) as integer
'               Translates the bit indexes for the register tabs to their
'               bit numbers so I can update the registers
'*********************************************************************
Function BitIndexToBit(Index As Integer) As Integer
Select Case Index
    Case 3, 4, 12, 15, 23, 29
        BitIndexToBit = 0
    Case 5, 13, 16, 24, 30
        BitIndexToBit = 1
    Case 6, 14, 17, 25, 31
        BitIndexToBit = 2
    Case 7, 18
        BitIndexToBit = 3
    Case 8, 19, 26, 32
        BitIndexToBit = 4
    Case 9, 20, 27, 33
        BitIndexToBit = 5
    Case 10, 21, 28, 34
        BitIndexToBit = 6
    Case 2, 11, 22
        BitIndexToBit = 7
End Select
End Function
Public Function between(Test As Integer, A As Integer, B As Integer) As Boolean
    If (B > A) And (Test >= A) And (Test <= B) Then
        between = True
    Else
        between = False
    End If
    
End Function

Public Function Find_A_Standard_Resistor(R)
Dim Rstd(696)
Dim i, best_resistor, delta_min, best_resistor_i
Rstd(1) = 10
Rstd(2) = 10.2
Rstd(3) = 10.5
Rstd(4) = 10.7
Rstd(5) = 11
Rstd(6) = 11.3
Rstd(7) = 11.5
Rstd(8) = 11.8
Rstd(9) = 12
Rstd(10) = 12.1

Rstd(11) = 12.4
Rstd(12) = 12.7
Rstd(13) = 13
Rstd(14) = 13.3
Rstd(15) = 13.7
Rstd(16) = 14
Rstd(17) = 14.3
Rstd(18) = 14.7
Rstd(19) = 15
Rstd(20) = 15.4

Rstd(21) = 15.8
Rstd(22) = 16
Rstd(23) = 16.2
Rstd(24) = 16.5
Rstd(25) = 16.9
Rstd(26) = 17.4
Rstd(27) = 17.8
Rstd(28) = 18
Rstd(29) = 18.2
Rstd(30) = 18.7

Rstd(31) = 19.1
Rstd(32) = 19.6
Rstd(33) = 20
Rstd(34) = 20.5
Rstd(35) = 21
Rstd(36) = 21.5
Rstd(37) = 22
Rstd(38) = 22.1
Rstd(39) = 22.6
Rstd(40) = 23.2

Rstd(41) = 23.7
Rstd(42) = 24
Rstd(43) = 24.3
Rstd(44) = 24.7
Rstd(45) = 24.9
Rstd(46) = 25.5
Rstd(47) = 26.1
Rstd(48) = 26.7
Rstd(49) = 27
Rstd(50) = 27.4

Rstd(51) = 28
Rstd(52) = 28.7
Rstd(53) = 29.4
Rstd(54) = 30
Rstd(55) = 30.1
Rstd(56) = 30.9
Rstd(57) = 31.6
Rstd(58) = 32.4
Rstd(59) = 33
Rstd(60) = 33.2

Rstd(61) = 34
Rstd(62) = 34.8
Rstd(63) = 35.7
Rstd(64) = 36
Rstd(65) = 36.5
Rstd(66) = 37.4
Rstd(67) = 38.3
Rstd(68) = 39
Rstd(69) = 39.2
Rstd(70) = 40.2

Rstd(71) = 41.2
Rstd(72) = 42.2
Rstd(73) = 43
Rstd(74) = 43.2
Rstd(75) = 44.2
Rstd(76) = 45.3
Rstd(77) = 46.4
Rstd(78) = 47
Rstd(79) = 47.5
Rstd(80) = 48.7

Rstd(81) = 49.9
Rstd(82) = 51
Rstd(83) = 51.1
Rstd(84) = 52.3
Rstd(85) = 53.6
Rstd(86) = 54.9
Rstd(87) = 56
Rstd(88) = 56.2
Rstd(89) = 57.6
Rstd(90) = 59

Rstd(91) = 60.4
Rstd(92) = 61.9
Rstd(93) = 62
Rstd(94) = 63.4
Rstd(95) = 64.9
Rstd(96) = 66.5
Rstd(97) = 68
Rstd(98) = 68.1
Rstd(99) = 69.8
Rstd(100) = 71.5

Rstd(101) = 73.2
Rstd(102) = 75
Rstd(103) = 75.5
Rstd(104) = 76.8
Rstd(105) = 78.7
Rstd(106) = 80.6
Rstd(107) = 82
Rstd(108) = 82.5
Rstd(109) = 84.5
Rstd(110) = 86.6

Rstd(111) = 88.7
Rstd(112) = 90.9
Rstd(113) = 91
Rstd(114) = 93.1
Rstd(115) = 95.3
Rstd(116) = 97.6
'Rstd(127) = 100

For i = 1 To 116
Rstd(116 + i) = Rstd(i) * 10 'to 1k
Next i

For i = 1 To 116
Rstd(232 + i) = Rstd(i) * 100 'to 10k
Next i

For i = 1 To 116
Rstd(348 + i) = Rstd(i) * 1000 'to 100k
Next i

For i = 1 To 116
Rstd(464 + i) = Rstd(i) * 10000 'to 1M
Next i

For i = 1 To 116
Rstd(580 + i) = Rstd(i) * 100000 'to 10M
Next i
best_resistor = 100000000#

For i = 1 To 696
delta_min = Abs(R - Rstd(i))
If delta_min < best_resistor Then
best_resistor = delta_min
best_resistor_i = i
End If
Next i
Find_A_Standard_Resistor = Rstd(best_resistor_i)
End Function

Public Function FindRsetMax(Vref, Iout_max, Iout_min, Rmax, Rmin, Rvi)
Dim Iref
If frmRegDetail.Combo1 = "Voltage" Then
    Iref = (Iout_max - Iout_min) / (400 * (Rmax - Rmin))
Else
    Iref = Rvi * (Iout_max - Iout_min) / (50 * 400 * (Rmax - Rmin))
End If
    'Iref = Rvi * (Iout_max - Iout_min) / (50 * 400 * (Rmax - Rmin))
    FindRsetMax = 5 * Vref / Iref
    If FindRsetMax < 12100# Then
        FindRsetMax = 0
        ErrorMsg = ErrorMsg + "Cannot find an acceptable value for Rset!  Channel= " + Str(xi + 1) + vbCrLf
        error_flag = 1
    End If
End Function
Public Function FindRsetMin(Vref, Iout_max, Iout_min, Rmax, Rmin, Rvi)
Dim Iref
If frmRegDetail.Combo1 = "Voltage" Then
    Iref = (Iout_max - Iout_min) / (6.25 * (Rmax - Rmin)) 'voltage mode
Else
    Iref = Rvi * (Iout_max - Iout_min) / (50 * 6.25 * (Rmax - Rmin))
End If
    FindRsetMin = 5 * Vref / Iref
    If FindRsetMin < 12100 Then
    FindRsetMin = 12100
    End If
End Function
Public Function FindGain(Vref, R_set, Iref, Iout_max, Iout_min, Rmax, Rmin, Rvi)
Dim A_PGA(8), max_gain, Gain, del_min, i, delta_I
max_gain = 5 * Vref / R_set
A_PGA(1) = 6.25
A_PGA(2) = 12.5
A_PGA(3) = 25
A_PGA(4) = 50
A_PGA(5) = 100
A_PGA(6) = 200
A_PGA(7) = 400
Gain = 6.26
del_min = 1000000#
For i = 1 To 7
    If frmRegDetail.Combo1 = "Voltage" Then
        Iref = (Iout_max - Iout_min) / (A_PGA(i) * (Rmax - Rmin))
    Else
        Iref = Rvi * (Iout_max - Iout_min) / (50 * A_PGA(i) * (Rmax - Rmin))
    End If
    delta_I = Abs(Iref - (5 * Vref / R_set))
    If delta_I < del_min Then
        Gain = A_PGA(i)
        del_min = delta_I
    End If
Next i
If del_min > 0.35 * (5 * Vref / R_set) Then
    FindGain = -1
    ErrorMsg = ErrorMsg + "Can't find a valid gain.  Channel= " + Str(xi + 1) + vbCrLf
    error_flag = 1
Else
    FindGain = Gain
End If


End Function
Public Function Maximum_of_Array(x_array)
Maximum_of_Array = -1E+99
Dim xxi
Max_Index = -1
For xxi = 0 To 4
    If FindRes_RTD(xxi) <> 0 Then
        If x_array(xxi) > Maximum_of_Array Then
            Maximum_of_Array = x_array(xxi)
            Max_Index = xxi
        End If
    End If
Next xxi

End Function

Public Function Minimum_of_Array(x_array)
Minimum_of_Array = 1E+99
Dim xxi
Min_Index = -1
For xxi = 0 To 4
    If FindRes_RTD(xxi) <> 0 Then
        If x_array(xxi) < Minimum_of_Array Then
            Minimum_of_Array = x_array(xxi)
            Min_Index = xxi
        End If
    End If
Next xxi
End Function

