VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.MDIForm frmMDIMain 
   BackColor       =   &H8000000C&
   Caption         =   "Texas Instruments XTR108-EVM Application"
   ClientHeight    =   8310
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   12030
   Icon            =   "mdimain.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Left            =   4320
      Top             =   2400
   End
   Begin MSCommLib.MSComm pCommPort 
      Left            =   4800
      Top             =   1560
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   0   'False
      InBufferSize    =   64
      RThreshold      =   1
   End
   Begin MSComDlg.CommonDialog dlgCommon 
      Left            =   2055
      Top             =   2295
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.PictureBox dlgSaveAs 
      Align           =   1  'Align Top
      Height          =   435
      Left            =   0
      ScaleHeight     =   375
      ScaleWidth      =   11970
      TabIndex        =   0
      Top             =   0
      Width           =   12030
      Begin MSComctlLib.Toolbar Toolbar1 
         Height          =   390
         Left            =   0
         TabIndex        =   1
         Top             =   0
         Width           =   12000
         _ExtentX        =   21167
         _ExtentY        =   688
         ButtonWidth     =   609
         ButtonHeight    =   582
         Appearance      =   1
         ImageList       =   "imlToolbarIcons"
         _Version        =   393216
         BeginProperty Buttons {66833FE8-8583-11D1-B16A-00C0F0283628} 
            NumButtons      =   3
            BeginProperty Button1 {66833FEA-8583-11D1-B16A-00C0F0283628} 
               Key             =   "New"
               Object.ToolTipText     =   "Reset All"
               ImageKey        =   "New"
            EndProperty
            BeginProperty Button2 {66833FEA-8583-11D1-B16A-00C0F0283628} 
               Key             =   "Open"
               Object.ToolTipText     =   "Open"
               ImageKey        =   "Open"
            EndProperty
            BeginProperty Button3 {66833FEA-8583-11D1-B16A-00C0F0283628} 
               Key             =   "Save"
               Object.ToolTipText     =   "Save"
               ImageKey        =   "Save"
            EndProperty
         EndProperty
      End
   End
   Begin MSComctlLib.ImageList imlToolbarIcons 
      Left            =   3120
      Top             =   2400
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   4
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "mdimain.frx":0CCA
            Key             =   "New"
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "mdimain.frx":120E
            Key             =   "Open"
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "mdimain.frx":1752
            Key             =   "Save"
         EndProperty
         BeginProperty ListImage4 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "mdimain.frx":1C96
            Key             =   "Print"
         EndProperty
      EndProperty
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuNew 
         Caption         =   "&Reset All"
      End
      Begin VB.Menu mnuLoad 
         Caption         =   "&Load Setup"
      End
      Begin VB.Menu mnuSave 
         Caption         =   "&Save Setup"
      End
      Begin VB.Menu mnuSaveAs 
         Caption         =   "Save &As"
      End
      Begin VB.Menu menExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuEEPROM 
      Caption         =   "&EEPROM"
   End
   Begin VB.Menu mnuSetup 
      Caption         =   "&Setup"
      Index           =   1
      Begin VB.Menu mnuCoef 
         Caption         =   "E&nter Callendar-Van Dusen Coefficients"
      End
      Begin VB.Menu mnuIso 
         Caption         =   "Turn on the ISO Supply Continuously"
      End
      Begin VB.Menu mnuReset 
         Caption         =   "Reset to Default Values"
      End
      Begin VB.Menu mnuGeneral 
         Caption         =   "C&ommunications Setup..."
      End
      Begin VB.Menu mnu_user_defined_mux 
         Caption         =   "Disable automatic mux selection"
      End
   End
   Begin VB.Menu mnuSetup 
      Caption         =   "&View"
      Index           =   2
      Begin VB.Menu mnuRegValues 
         Caption         =   "&Register Values..."
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuAbout 
         Caption         =   "&About..."
      End
   End
End
Attribute VB_Name = "frmMDIMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Enum inputState_t
        none = 0         'Waiting for an S
        InMessage        'During the message
        MessageComplete  'Complete. Any new characters are not relevant and thrown away
End Enum
Private Enum Commands_t
    NOP = 1
    WriteRegister
    WriteAllRegisters
    ReadAllRegisters
    WriteEEPROM
    ReadEEPROM
End Enum
Dim LastRequest As Integer      'The last message sent, so I know what to do with the response
Dim Response As String, ResponseValid As Boolean
Private inputState As inputState_t
Private frmEEPROMOpen As Boolean

Private Sub Command1_Click()
End Sub

Private Sub MDIForm_Load()
    Dim i As Integer
On Error GoTo err
    frmSplash.Show
    frmSplash.Refresh
    InitializeData
    InitializeFindResistors
    Load frmRegDetail
    user_defined_mux = False
    Unload frmSplash
    
    frmRegDetail.Show
    If (LastMonthChecked < Month(Now)) Or (LastYearChecked < Year(Now)) Then
        LastMonthChecked = Month(Now)
        LastYearChecked = Year(Now)
        frmCheckSoftwareRev.Show vbModal
    End If

    
Exit Sub
err:
    err.Source = err.Source & Chr(10) & "frmMDIMain.MDIForm_Load"
    MsgBox err.Description & Chr(10) & err.Source

End Sub

Private Sub MDIForm_Unload(Cancel As Integer)
Open "xtr108_config.txt" For Output As #1
Write #1, ResRlin
Write #1, ResRset
Write #1, ResRvi
Write #1, RZ(1)
Write #1, RZ(2)
Write #1, RZ(3)
Write #1, RZ(4)
Write #1, RZ(5)
Write #1, RTD_Base
Write #1, AK
Write #1, BK
Write #1, CK
Write #1, LastMonthChecked
Write #1, LastYearChecked
Write #1, Path
Close #1

Call SaveFindResistorsDefault

End Sub

Private Sub menExit_Click()
If MsgBox("Do you wish to exit the program?", vbYesNo, "Exit Program") = vbYes Then
    End
End If
End Sub

Private Sub mnu_user_defined_mux_Click()
If mnu_user_defined_mux.Checked = False Then
    user_defined_mux = True
    mnu_user_defined_mux.Checked = True
Else
    user_defined_mux = False
    mnu_user_defined_mux.Checked = False
End If
End Sub

Private Sub mnuAbout_Click()
Load frmAbout
frmAbout.Show vbModal
End Sub

Private Sub mnuCommunications_Click()
Load frmGeneralSetup
frmGeneralSetup.Show
End Sub

Private Sub mnuCoef_Click()
  Load frmCoef
  frmCoef.Show vbModal
  Unload frmCoef
 
End Sub

'************************************
'   Bring up the form to show the EEPROM
'
'*************************************
Private Sub mnuEEPROM_Click()
    Load frmEEPROM
    frmEEPROMOpen = True
    frmEEPROM.Show vbModal
    frmEEPROMOpen = False
    Unload frmEEPROM
End Sub

Private Sub mnuGeneral_Click()
Load frmGeneralSetup
frmGeneralSetup.Show vbModal
End Sub



Private Sub mnuReconnect_Click()

End Sub

Private Sub mnuIso_Click()
If Viso_enable = True Then
    Viso_enable = False
    mnuIso.Checked = False
    Call TurnOffDCtoDC
Else
    Viso_enable = True
    mnuIso.Checked = True
    Call TurnOnDCtoDC
End If
End Sub

'*************************************************************
'       mnuLoad_Click
'       This subroutine fetches a saved document from disk
'**************************************************************
Private Sub mnuLoad_Click()
Dim file As Integer
' Set CancelError is True
dlgCommon.CancelError = True
On Error GoTo err
' Set Title
dlgCommon.DialogTitle = "Save Calibration Data"
' Set flags
'dlgLoadMacroFile.Flags = cdlOFNHideReadOnly
' Set filters
dlgCommon.Filter = "Calibration Files (*.txt)|*.txt"
' Specify default filter
dlgCommon.FilterIndex = 1
' Display the Save As dialog box
If Path <> "" Then dlgCommon.FileName = Path
dlgCommon.ShowOpen
Path = dlgCommon.FileName
file = openFile(Path, True)
readDocument (file)
closeFile (file)
frmRegDetail.UpdateEverything

Exit Sub
err:
    'Detect Cancel here
    If err.Number <> 32755 Then
        err.Source = err.Source & Chr(10) & "frmMDIMain:mnuSaveAs_Click"
        MsgBox err.Description & Chr(10) & err.Source
    End If
End Sub





Private Sub mnuNew_Click()
    InitializeData
    frmRegDetail.UpdateEverything
End Sub

'Private Sub mnuRegisterDetails_Click()
'Load frmRegDetail
'frmRegDetail.Show
'End Sub

Private Sub mnuRegValues_Click()
Load frmXTRRegisters
frmXTRRegisters.Show
End Sub

Private Sub mnuReset_Click()
Dim i
Answer$ = MsgBox("This will reset to the default values for saved resistor values, and coeficient values." + vbCrLf + "Are you sure you want to do this?", vbYesNo)
If Answer$ = vbYes Then
Call DefaultFindResistors
Call UpdateDisplayFindResistors

ResRset = 12100
ResRlin = 15800
ResRvi = 6340

frmRegDetail.txtRLin(0) = ResRlin
frmRegDetail.txtRLin(1) = ResRlin
frmRegDetail.txtRSet(0) = ResRset
frmRegDetail.txtRSet(1) = ResRset
frmRegDetail.txtRvi(0) = ResRvi
frmRegDetail.txtRvi(1) = ResRvi

For i = 0 To 4
    frmRegDetail.txtCalRz(i + 1) = FindRes_Rz(i)
    frmRegDetail.txtSumRz(i + 1) = FindRes_Rz(i)
    RZ(i + 1) = FindRes_Rz(i)
Next i

AK = 0.0039083
BK = -0.0000005775
CK = -4.1835E-12

End If
End Sub

Private Sub mnuSave_Click()
Dim file As Integer
If Path <> "" Then
    file = openFile(Path)
    writeDocument (file)
    closeFile (file)
Else
    mnuSaveAs_Click
End If
End Sub

Private Sub mnuSaveAs_Click()
Dim file As Integer
' Set CancelError is True
dlgCommon.CancelError = True
On Error GoTo ErrHandler
' Set Title
dlgCommon.DialogTitle = "Save Calibration Data"
' Set flags
'dlgLoadMacroFile.Flags = cdlOFNHideReadOnly
' Set filters
dlgCommon.Filter = "Calibration Files (*.txt)|*.txt"
' Specify default filter
dlgCommon.FilterIndex = 1
' Display the Save As dialog box
If Path <> "" Then dlgCommon.FileName = Path
dlgCommon.ShowSave
Path = dlgCommon.FileName
file = openFile(Path)
writeDocument (file)
closeFile (file)
Exit Sub
ErrHandler:
    'Detect Cancel here
    If err.Number <> 32755 Then
        err.Source = err.Source & Chr(10) & "frmMDIMain:mnuSaveAs_Click"
        MsgBox err.Description & Chr(10) & err.Source
    End If
End Sub
'*********************************************
'   pCommPort_OnComm
'         Interrupt back from the comm port.
'         Will gather the message.
'
'**********************************************
Private Sub pCommPort_OnComm()
On Error GoTo OnComm_err
   Dim InputChars As String
   Dim i As Integer, nextChar As String
   
   

   Select Case pCommPort.CommEvent   ' Handle each event or error by placing
   ' code below each case statement   ' Errors
      Case comEventRxOver   ' Receive buffer overflow.
      Case comEventRxParity   ' Parity Error.
      Case comEventTxFull   ' Transmit buffer full.
      Case comEventDCB   ' Unexpected error retrieving DCB]   ' Events
      Case comEvCD   ' Change in the CD line.
      Case comEvCTS   ' Change in the CTS line.
      Case comEvDSR   ' Change in the DSR line.
      Case comEvRing   ' Change in the Ring Indicator.
      Case comEvReceive   ' Received RThreshold # of
                        ' chars.
         InputChars = pCommPort.Input
         
         For i = 1 To Len(InputChars)
            nextChar = Mid(InputChars, i, 1)     'Get the char
            Select Case inputState
                Case none:
                    If nextChar = "S" Then
                        inputState = InMessage
                        Response = ""
                    End If
                Case InMessage:
                    If nextChar = "T" Then
                        inputState = MessageComplete
                        ResponseValid = True
                    Else
                        Response = Response & nextChar
                    End If
                Case MessageComplete:
                    
                    'ignore anything else
            End Select
         Next i
         
      Case comEvSend   ' There are SThreshold number of
                     ' characters in the transmit                     ' buffer.
      Case comEvEOF   ' An EOF charater was found in
                     ' the input stream
   End Select
OnComm_exit:
   Exit Sub
OnComm_err:
   err.Source = err.Source & "frmMain:OnComm"
   MsgBox err.Description & Chr(10) & err.Source
End Sub
Public Sub startCommPort()
On Error GoTo err
If pCommPort.PortOpen = False Then
    pCommPort.CommPort = CurrentCommPort
    pCommPort.Settings = "19200,N,8,1"
    pCommPort.PortOpen = True
End If
Exit Sub
err:
    err.Source = err.Source & Chr(10) & "frmMDIMain:startCommPort"
    err.Raise err.Number
End Sub
Public Sub closeCommPort()
On Error GoTo err
'    pCommPort.PortOpen = False
Exit Sub
err:
    err.Source = err.Source & Chr(10) & "frmMDIMain: closeCommPort"
End Sub
Public Sub sendCommand(cmd As Integer, data As String)
Dim TotalString As String
On Error GoTo err
    TotalString = toASCII((Len(data) / 2) + 5) & toASCII(cmd) & data
    TotalString = TotalString & GenerateCheckChars(TotalString)
    TotalString = "S" & TotalString & "T"
    startCommPort
    pCommPort.Output = TotalString
    LastRequest = cmd
    Timer1.Interval = 100       'Give it 100 ms. to respond.
Exit Sub
err:
    err.Source = err.Source & Chr(10) & "frmMDIMain:sendCommand"
    err.Raise err.Number
End Sub

Private Sub Timer1_Timer()
Timer1.Interval = 0
closeCommPort
If (ResponseValid) Then
    If verifyMessage(Response) Then
        handleResponse
    End If
Else
    MsgBox "We have lost contact with the EVM!"
End If
Response = ""
ResponseValid = False
inputState = none
End Sub
Private Sub handleResponse()
Select Case LastRequest
    Case NOP:
    Case WriteAllRegisters:
    Case WriteEEPROM:
    Case ReadAllRegisters:
        HandleReadRegisters
    Case ReadEEPROM:
        HandleReadEEPROM
    Case Else:
End Select
End Sub
Public Sub HandleReadRegisters()
Dim ResponseString As String
Dim i As Integer

ResponseString = Mid$(Response, 5, 32)
For i = 0 To 15
    Call globals.WriteRegister(i, Mid$(ResponseString, 1 + (2 * i), 2))
    'Registers(i) = Int(toHex(Mid$(ResponseString, 1 + (2 * i), 2)))
Next i
frmRegDetail.UpdateEverything
End Sub
Public Sub HandleReadEEPROM()
Dim ResponseString As String
Dim i As Integer
ResponseString = Mid$(Response, 5, 32)
If frmEEPROMOpen = True Then
    frmEEPROM.ReadEEPROM (ResponseString)
Else
    For i = 0 To 15
        Call globals.WriteRegister(i, Mid$(ResponseString, 1 + (2 * i), 2))
        'Registers(i) = Int(toHex(Mid$(ResponseString, 1 + (2 * i), 2)))
    Next i
    frmRegDetail.UpdateEverything
End If
End Sub

Private Function openFile(FilePath As String, Optional readfile As Boolean = False) As Integer
On Error GoTo err
    openFile = FreeFile
    If readfile Then
        Open FilePath For Input As openFile
    Else
        Open FilePath For Output As openFile
    End If
Exit Function
err:
    err.Source = err.Source & Chr(10) & "frmMDIMain:openFile"
    err.Raise err.Number
End Function
Private Sub closeFile(file)
On Error GoTo err
    Close file
Exit Sub
err:
    err.Source = err.Source & Chr(10) & "frmMDIMain:closeFile"
    err.Raise err.Number
End Sub

Private Sub writeDocument(file As Integer)
Dim i As Integer
Dim VI As String

On Error GoTo err
    Print #file, "'XTR108 Setup File"
    For i = 0 To 15
        Print #file, "Register(" & i & ") = " & AddZero(Registers(i))
    Next i
    For i = 1 To 5
        Print #file, "Rz(" & i & ") = " & RZ(i)
    Next i
    Print #file, "Rset = " & ResRset
    Print #file, "Rlin = " & ResRlin
    Print #file, "Rvi  = " & ResRvi
    Print #file, "RTD  = " & RTD_Base
    Print #file, "Tmin = " & frmRegDetail.txtTempMin
    Print #file, "Tmax = " & frmRegDetail.txtTempMax
    VI = IIf(frmRegDetail.cbxCalDesLoop = "Current", "I", "V")
    Print #file, VI & "Tmax = " & frmRegDetail.txtVIMaxTemp
    Print #file, VI & "Tmin = " & frmRegDetail.txtVIMinTemp

Exit Sub
err:
    err.Source = err.Source & Chr(10) & "frmMDIMain:writeDocument"
    err.Raise err.Number
End Sub
Private Sub readDocument(file As Integer)
Dim fileData As String, item As String, value As String
Dim tokenLoc As Integer
On Error GoTo err
While Not EOF(file)
    Line Input #file, fileData
    If Left(fileData, 1) <> "'" Then        'Skip Comments
        tokenLoc = InStr(1, fileData, "=")
        item = Trim(Left(fileData, tokenLoc - 1))
        value = Trim(Right(fileData, Len(fileData) - tokenLoc))
        Call saveData(item, value)
    End If
Wend
Exit Sub
err:
    err.Source = err.Source & Chr(10) & "frmMDIMain:readDocument"
    err.Raise err.Number
End Sub

Private Function saveData(item As String, value As String) As Boolean
Dim tokenLoc As Integer
Dim regNum As Integer
saveData = True
On Error GoTo err
    tokenLoc = InStr(1, item, "(")      'Get rid of the (n)
    If tokenLoc = 0 Then tokenLoc = Len(item)
    Select Case Left$(item, tokenLoc)
    Case "Rset":
        ResRset = Val(value)
    Case "Rlin":
        ResRlin = Val(value)
    Case "Rvi":
        ResRvi = Val(value)
    Case "RTD":
        RTD_Base = Val(value)
    Case "Tmin":
        frmRegDetail.txtTempMin = Val(value)    'need to update calculated values
    Case "Tmax":
        frmRegDetail.txtTempMax = Val(value)
    Case "ITmin":
        frmRegDetail.txtVIMinTemp = Val(value)
        frmRegDetail.cbxCalDesLoop = "Current"
    Case "ITmax":
        frmRegDetail.txtVIMaxTemp = Val(value)
        frmRegDetail.cbxCalDesLoop = "Current"
    Case "VTmin":
        frmRegDetail.txtVIMinTemp = Val(value)
        frmRegDetail.cbxCalDesLoop = "Voltage"
    Case "VTmax"
        frmRegDetail.txtVIMaxTemp = Val(value)
        frmRegDetail.cbxCalDesLoop = "Voltage"
    Case "Register("
        regNum = Val(Right(Left(item, Len(item) - 1), Len(item) - tokenLoc - 1))
        Registers(regNum) = toHex(value)
    Case "Rz(":
        regNum = Val(Right(Left(item, Len(item) - 1), Len(item) - tokenLoc - 1))
        RZ(regNum) = Val(value)
    Case Else:
        MsgBox "This is not a valid setup file"
        saveData = False
    End Select
    
Exit Function
err:
    err.Source = err.Source & Chr(10) & "frmMDIMain:saveData"
    err.Raise err.Number
End Function

Private Sub Toolbar1_ButtonClick(ByVal Button As MSComctlLib.Button)
  On Error Resume Next
    Select Case Button.Key
        Case "New"
            mnuNew_Click
        Case "Open"
            mnuLoad_Click
        Case "Save"
            mnuSave_Click
        Case "Print"
            'mnuFilePrint_Click
    End Select
End Sub
Public Sub ReadAllXTRRegs()
    Call sendCommand(4, "")     'ReadAllRegisters
End Sub
Public Sub WriteAllXTRRegs(Values As String)
    Call sendCommand(3, Values)
End Sub
